using PkmnLib.Plugin.Gen7.Scripts.Utils;

namespace PkmnLib.Plugin.Gen7.Scripts.Pokemon;

[Script(ScriptCategory.Pokemon, "phantom_force")]
public class PhantomForceCharge : Script, IScriptForceTurnSelection, IScriptBlockIncomingHit, IScriptOnAfterMoveChoice
{
    private readonly IPokemon _owner;

    public PhantomForceCharge(IPokemon owner)
    {
        _owner = owner;
    }

    /// <inheritdoc />
    public void ForceTurnSelection(IBattle battle, byte sideIndex, byte position, ref ITurnChoice? choice)
    {
        var opposingSideIndex = (byte)(_owner.BattleData?.SideIndex == 0 ? 1 : 0);
        choice = TurnChoiceHelper.CreateMoveChoice(_owner, "phantom_force", opposingSideIndex, position);
    }

    /// <inheritdoc />
    public void BlockIncomingHit(IExecutingMove executingMove, IPokemon target, byte hitIndex, ref bool block)
    {
        block = true;
    }

    /// <inheritdoc />
    public void OnAfterMoveChoice(IMoveChoice moveChoice)
    {
        if (moveChoice.AdditionalData?.ContainsKey("phantom_force_charge") != true)
        {
            moveChoice.User.Volatile.Remove(ScriptUtils.ResolveName<PhantomForceCharge>());
        }
    }
}